from Screens.Screen import Screen
from Screens.Console import Console
from Screens.MessageBox import MessageBox
from Components.Pixmap import Pixmap
from Components.Sources.StaticText import StaticText
from Components.Button import Button
from Components.Label import Label
from Components.MenuList import MenuList
from Components.ActionMap import ActionMap
from Plugins.Plugin import PluginDescriptor
from enigma import eTimer
import os
import gettext
from os import environ
from Tools.Directories import fileExists, resolveFilename, SCOPE_PLUGINS, SCOPE_LANGUAGE
from Components.Language import language
lang = language.getLanguage()
environ['LANGUAGE'] = lang[:2]
gettext.bindtextdomain('enigma2', resolveFilename(SCOPE_LANGUAGE))
gettext.textdomain('enigma2')
gettext.bindtextdomain('ScalingModes', '%s%s' % (resolveFilename(SCOPE_PLUGINS), 'Extensions/ScalingModes/locale/'))

def _(txt):
    t = gettext.dgettext('ScalingModes', txt)
    if t == txt:
        t = gettext.gettext(txt)
    return t


lista = []
modos = []
escalas = []
modos.append(('16:9', '16 9'))
modos.append(('4:3', '4 3'))
modos.append(('16:10', '16 10'))
modos.append(('14:9', '14 9'))
escalas.append(('Normal', '0'))
escalas.append(('Pillarbox', '3'))
escalas.append(('Vertical center', '4'))

def anadevalor(ertexto, ervalor, actresx, xmodo = None):
    global lista
    if ervalor == actresx:
        ertexto = ertexto + ' *'
    if ervalor == xmodo:
        ertexto = ertexto + ' x'
    lista.append((ertexto, ervalor))


def inicia(ermodo = None):
    global escalas
    global lista
    global modos
    lista = []
    actres = open('/proc/aspectratio', 'r').read().replace('\n', '')
    if not actres == '':
        ana = ''
        if not actres == '0 0':
            ana = ' (' + actres.replace(' ', ':') + ')'
        lista.append((_('Auto') + ana, actres + ',0'))
        lista.append(('----------------------------------------------------------', None))
    for xon in range(len(modos)):
        if modos[xon][1] == actres:
            pass
        else:
            for pon in range(len(escalas)):
                lista.append((_(modos[xon][0] + ' ' + escalas[pon][0]), modos[xon][1] + ',' + escalas[pon][1]))

            lista.append(('----------------------------------------------------------', None))

    fon = 0
    for xon in range(len(modos)):
        if modos[xon][1] == actres:
            pass
        else:
            fon = fon + 1
            lista.append((_('Zoom' + str(fon)), modos[xon][1] + ',1'))

    lista.append(('--------[' + _('AV Setup') + ']------------------------------------------', 'Menu'))
    lista.append(('--------[' + _('Brigtness setup') + ']------------------------------------------', 'Brillo'))
    return None


def setModo(value1, modo = 'scalingmode'):
    try:
        open('/proc/' + modo, 'w').write(str(value1))
        open('/proc/' + modo, 'w').close()
    except:
        pass


def ponmodo(returnValue):
    if returnValue is not None:
        rlista = returnValue.split(',')
        os.system('echo "' + rlista[0] + '" > /proc/aspectratio &')
        setModo(rlista[1], 'scalingmode')
        return True
    else:
        return False


class infoMode(Screen):
    skin = '\n\t\t<screen position="960,50" size="280,30" title="%s" >\n\t\t\t<widget name="texto" position="0,0" size="280,30" valign="center" halign="center" font="Regular;20" />\n \t\t</screen>' % _('Aspect')

    def __init__(self, session, modo, numero):
        self.session = session
        Screen.__init__(self, session)
        self['texto'] = Label('')
        self.tmodo = modo
        self.umodo = None
        self.tnumero = numero
        self.TimerTemp = eTimer()
        self.TimerTemp.callback.append(self.exit)
        self.TimerPon = eTimer()
        self.TimerPon.callback.append(self.pmodo)
        self.lista = []
        for ele in lista:
            if not ele[1] == None and not ele[1] == 'Menu' and not ele[1] == 'Brillo':
                self.lista.append(ele)

        self['actions'] = ActionMap(['DirectionActions',
         'ShortcutActions',
         'WizardActions',
         'EPGSelectActions'], {'ok': self.exit,
         'green': self.exit,
         'red': self.exit,
         'back': self.exit,
         'info': self.exit,
         'left': self.kleft,
         'right': self.krigth,
         'up': self.kleft,
         'down': self.krigth}, -1)
        self.onLayoutFinish.append(self.mostrar)
        return

    def pmodo(self):
        self.TimerPon.stop()
        self.TimerTemp.stop()
        ret = ponmodo(self.umodo)
        self['texto'].setText(self.lista[self.tnumero][0] + '')
        self.TimerTemp.startLongTimer(3)

    def kleft(self):
        self.TimerPon.stop()
        self.TimerTemp.stop()
        try:
            self.tnumero -= 1
            if self.tnumero < 0:
                self.tnumero = len(self.lista) - 1
            self.umodo = self.lista[self.tnumero][1]
            self['texto'].setText('<> ' + self.lista[self.tnumero][0] + '...')
            self.TimerPon.startLongTimer(1)
        except:
            pass

    def krigth(self):
        self.TimerPon.stop()
        self.TimerTemp.stop()
        try:
            self.tnumero += 1
            if self.tnumero >= len(self.lista):
                self.tnumero = 0
            self.umodo = self.lista[self.tnumero][1]
            self['texto'].setText('<> ' + self.lista[self.tnumero][0] + '...')
            self.TimerPon.startLongTimer(1)
        except:
            pass

    def mostrar(self):
        self['texto'].setText('<> ' + self.tmodo + '')
        self.TimerTemp.startLongTimer(3)

    def exit(self):
        self.TimerPon.stop()
        self.TimerTemp.stop()
        self.close(True)


class ScreenModes(Screen):
    skin = '\n\t\t<screen position="30,50" size="300,445" title="%s" >\n\t\t\t<widget name="myMenu" position="10,10" size="280,425" scrollbarMode="showOnDemand" />\n \t\t</screen>' % _('Scaling modes')

    def __init__(self, session, args = 0):
        self.session = session
        inicia()
        self.modo1 = None
        self.modo2 = ''
        Screen.__init__(self, session)
        self['myMenu'] = MenuList(lista)
        self['actions'] = ActionMap(['DirectionActions',
         'MenuActions',
         'ShortcutActions',
         'WizardActions',
         'EPGSelectActions'], {'ok': self.ok,
         'green': self.ok,
         'red': self.cancel,
         'back': self.cancel,
         'left': self.kleft,
         'up': self.kup,
         'down': self.kdown,
         'right': self.krigth,
         'menu': self.key_menu,
         'info': self.info}, -1)
        self.onLayoutFinish.append(self.layoutFinished)
        return

    def kdown(self):
        if self['myMenu'].getSelectionIndex() == len(lista) - 1:
            self['myMenu'].moveToIndex(0)
        else:
            self['myMenu'].down()

    def kup(self):
        if self['myMenu'].getSelectionIndex() == 0:
            self['myMenu'].moveToIndex(len(lista) - 1)
        else:
            self['myMenu'].up()

    def brillo(self):
        try:
            from Plugins.SystemPlugins.VideoSettingsSetup.plugin import videoSettingsSetupMain
            videoSettingsSetupMain(self.session)
        except:
            pass

    def key_menu(self):
        try:
            from Plugins.SystemPlugins.Videomode.plugin import videoSetupMain
            videoSetupMain(self.session)
        except:
            pass

    def sel(self):
        Value = self['myMenu'].l.getCurrentSelection()[1]
        self.modo2 = self['myMenu'].l.getCurrentSelection()[0] + '_'
        inicia(Value)
        self['myMenu'].setList(lista)
        self.modo1 = Value

    def krigth(self):
        Numero = self['myMenu'].getSelectionIndex()
        valor = len(lista) - 1
        for xxx in range(Numero + 1, len(lista)):
            if lista[xxx][1] == None:
                valor = xxx + 1
                break

        self['myMenu'].moveToIndex(valor)
        return

    def kleft(self):
        Numero = self['myMenu'].getSelectionIndex()
        valor = 0
        for xxx in range(2, Numero):
            if lista[Numero - xxx][1] == None:
                valor = Numero - xxx + 1
                break

        self['myMenu'].moveToIndex(valor)
        return

    def layoutFinished(self):
        if fileExists('/tmp/scmode') and False:
            ret = ''
            try:
                flines = open('/tmp/scmode', 'r')
                for line in flines:
                    ret = ret + line.replace('\n', '')

                flines.close()
            except:
                pass

            defa = 1
            if len(ret) >= 1:
                for i in range(0, len(lista)):
                    if lista[i][1] == ret:
                        defa = i
                        break

                self['myMenu'].moveToIndex(defa)

    def info(self):
        aboutbox = self.session.open(MessageBox, _('Enigma2 Screen mode selector\n\nby spazeTeam 2011'), MessageBox.TYPE_INFO)
        aboutbox.setTitle(_('Scaling modes'))

    def ok(self):
        Value = self['myMenu'].l.getCurrentSelection()[1]
        texto = self['myMenu'].l.getCurrentSelection()[0]
        Numero = self['myMenu'].getSelectionIndex()
        if not self.modo1 == None:
            ponmodo(self.modo1)
        if Value == 'Menu':
            self.key_menu()
        elif Value == 'Brillo':
            self.brillo()
        elif ponmodo(Value):
            self.session.openWithCallback(self.cbinfo, infoMode, self.modo2 + texto, Numero)
        return

    def cbinfo(self, respuesta):
        self.close(None)
        return

    def execShell(self, com):
        self.session.open(Console, _('Execute: %s') % com, ['%s' % com], closeOnSuccess=True)

    def cancel(self):
        self.close(None)
        return


def main(session, **kwargs):
    session.open(ScreenModes)


def Plugins(**kwargs):
    name = _('Scaling modes')
    descr = _('Screen modes setup for Enigma2 RTI')
    return [PluginDescriptor(name=name, description=descr, where=PluginDescriptor.WHERE_EVENTINFO, fnc=main), PluginDescriptor(name=name, description=descr, where=[PluginDescriptor.WHERE_EXTENSIONSMENU], fnc=main)]